﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;

namespace WindowsFormsApplication27
{
    public partial class Form1 : Form
    {
        Point oldPosition;


        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            DataTable dt = new DataTable();
            dt.Columns.Add("Coll1", typeof(int)).AutoIncrement = true;

            for (int i = 0; i < 2000; i++)
                dt.Rows.Add();

            ultraGrid1.DataSource = dt;
            
            
        }

        private void ultraGrid1_MouseDown(object sender, MouseEventArgs e)
        {
            ultraGrid1.Capture = true;
            oldPosition = e.Location;
        }

        private void ultraGrid1_MouseUp(object sender, MouseEventArgs e)
        {
            if (ultraGrid1.Capture)
            {
                ultraGrid1.Capture = false;
            }
        }

        private void ultraGrid1_MouseMove(object sender, MouseEventArgs e)
        {
            if (ultraGrid1.Capture)
            {
                int abs = Math.Abs(e.Y - oldPosition.Y);
                if ( abs> 10)
                {
                    int adjust = (e.Y - oldPosition.Y);
                    int sign = adjust > -1 ? -1 : 1;
                    for (int i = 0; i < abs; i +=1)
                    {
                        ultraGrid1.DisplayLayout.RowScrollRegions[0].ScrollPosition += (int)(((e.Y - oldPosition.Y) + sign*i)*0.02);
                        ultraGrid1.Refresh();
                    }
                    
                    
                } 
                else
                    ultraGrid1.DisplayLayout.RowScrollRegions[0].ScrollPosition += e.Y - oldPosition.Y;
                oldPosition = e.Location;
            }
        }

    }
}
